Index: /trunk/src/sh_files.c
===================================================================
--- /trunk/src/sh_files.c	(revision 584)
+++ /trunk/src/sh_files.c	(revision 1)
@@ -2269,76 +1528,42 @@
       sh_error_handle (ShDFLevel[SH_ERR_T_DIR], FIL__, __LINE__, 0, 
 		       MSG_E_OPENDIR,
-		       sh_error_message (status, errbuf, sizeof(errbuf)), tmpname);
+		       sh_error_message (status), tmpname);
       SH_FREE(tmpname); 
+
       SL_RETURN((-1), _("sh_files_checkdir"));
     }
 
-  theDir = SH_ALLOC(sizeof(dir_type));
-
-  theDir->NumRegular  = 0;
-  theDir->NumDirs     = 0;
-  theDir->NumSymlinks = 0;
-  theDir->NumFifos    = 0;
-  theDir->NumSockets  = 0;
-  theDir->NumCDev     = 0;
-  theDir->NumBDev     = 0;
-  theDir->NumDoor     = 0;
-  theDir->NumPort     = 0;
-  theDir->NumAll      = 0;
-  theDir->TotalBytes  = 0;
-  sl_strlcpy (theDir->DirPath, iname, PATH_MAX); 
-
-
-  sh_dummy_dirlist = (void *) &dirlist;
-  sh_dummy_tmpcat  = (void *) &tmpcat;
+  theDir.NumRegular  = 0;
+  theDir.NumDirs     = 0;
+  theDir.NumSymlinks = 0;
+  theDir.NumFifos    = 0;
+  theDir.NumSockets  = 0;
+  theDir.NumCDev     = 0;
+  theDir.NumBDev     = 0;
+  theDir.NumAll      = 0;
+  theDir.TotalBytes  = 0;
+  sl_strlcpy (theDir.DirPath, iname, PATH_MAX); 
+
 
   /* ---- read ----
    */
-  SH_MUTEX_LOCK(mutex_readdir);
-
-  dirlist = NULL;
-  dirlist_orig = NULL;
-
-#if defined(SH_USE_SCANDIR)
-  entry = scandir(iname, &entryList, 0, alphasort);
-  while(entry > 0) { /* scandir() may return -1 on error! */
-      entry--;
-      thisEntry = entryList[entry];
-#else
   do {
       thisEntry = readdir (thisDir);
-#endif
       if (thisEntry != NULL) 
 	{
-	  ++theDir->NumAll;
+	  ++theDir.NumAll;
 	  if (sl_strcmp (thisEntry->d_name, ".") == 0)
 	    { 
-	      ++theDir->NumDirs;
-#if defined(SH_USE_SCANDIR)
-	      free(entryList[entry]); /* scandir() mallocs entries */
-#endif
+	      ++theDir.NumDirs;
 	      continue;
 	    }
 	  if (sl_strcmp (thisEntry->d_name, "..") == 0)
 	    {
-	      ++theDir->NumDirs;
-#if defined(SH_USE_SCANDIR)
-	      free(entryList[entry]); /* scandir() mallocs entries */
-#endif
+	      ++theDir.NumDirs;
 	      continue;
 	    }
 	  dirlist = addto_sh_dirlist (thisEntry, dirlist);
-#if defined(SH_USE_SCANDIR)
-	  free(entryList[entry]); /* scandir() mallocs entries */
-#endif
 	}
-  }
-#if defined(SH_USE_SCANDIR)
-  free(entryList);
-#else
-  while (thisEntry != NULL);
-#endif
-  
-  SH_MUTEX_UNLOCK(mutex_readdir);
+  } while (thisEntry != NULL);
 
   closedir (thisDir);
@@ -2357,12 +1582,10 @@
     if (sig_termfast == 1) 
       {
-	SH_FREE(theDir);
-	SH_FREE(tmpname);
 	SL_RETURN((0), _("sh_files_checkdir"));
       }
 
     BREAKEXIT(sh_derr);
-
-    if (0 == (simple_rand(&state) % 5)) (void) sh_derr();
+    if (0 == (rand() % 5))
+      (void) sh_derr();
     
     /* ---- Check the file. ---- 
@@ -2376,7 +1599,5 @@
     rdepth_next     = rdepth - 1;
     class_next      = class;
-    check_flags_next = check_flags;
     file_class_next = class;
-    file_check_flags_next = check_flags;
     checked_flag    = -1;
     cchecked_flag   = -1;
@@ -2386,6 +1607,4 @@
      * is checked with the policy of the parent directory
      */
-    SH_MUTEX_RECURSIVE_INIT(mutex_zdirs);
-    SH_MUTEX_RECURSIVE_LOCK(mutex_zdirs);
     dst_ptr         = (dirstack_t *) zAVLSearch(zdirListOne, tmpcat);
 
@@ -2397,7 +1616,7 @@
 	 */
 	file_class_next    = dst_ptr->class;
-	file_check_flags_next = dst_ptr->check_flags;
 	checked_flag       = dst_ptr->checked;
 	cchecked_flag      = dst_ptr->childs_checked;
+	break;
       }
 
@@ -2413,12 +1632,10 @@
 	     */
 	    file_class_next    = dst_ptr->class;
-	    file_check_flags_next = dst_ptr->check_flags;
 	    checked_flag       = dst_ptr->checked;
 	    cchecked_flag      = dst_ptr->childs_checked;
+	    break;
 	  }
       }
-    SH_MUTEX_RECURSIVE_UNLOCK(mutex_zdirs);
-
-    SH_MUTEX_LOCK_UNSAFE(mutex_zfiles);
+
     dst_ptr         = (dirstack_t *) zAVLSearch(zfileList, tmpcat);
 
@@ -2430,18 +1647,8 @@
 	 */
 	file_class_next    = dst_ptr->class;
-	file_check_flags_next = dst_ptr->check_flags;
 	checked_flag       = dst_ptr->checked;
-	/* not set, hence always FALSE                   */
-	/* cchecked_flag      = dst_ptr->childs_checked; */
-
-	if (checked_flag != S_TRUE)
-	  {
-	    /* -- need to check the file itself --
-	     */
-	    if (sh.flag.reportonce == S_TRUE)
-	      dummy = dst_ptr->is_reported;
-	  }
+	cchecked_flag      = dst_ptr->childs_checked;
+	break;
       }
-    SH_MUTEX_UNLOCK_UNSAFE(mutex_zfiles);
     
     /* ---- Has been checked already. ----
@@ -2454,5 +1661,5 @@
 	if (checkit == SH_FILE_DIRECTORY) 
 	  {
-	    ++theDir->NumDirs;
+	    ++theDir.NumDirs;
 	  }
 	SH_FREE(tmpcat);
@@ -2473,38 +1680,26 @@
 	/* -- need to check the file itself --
 	 */
-	/* -- moved up -- 
-	 * if (dst_ptr && sh.flag.reportonce == S_TRUE)
-	 *   dummy = dst_ptr->is_reported;
-	 */
-
-	checkit = sh_files_filecheck (file_class_next, file_check_flags_next, 
+	if (dst_ptr && sh.flag.reportonce == S_TRUE)
+	  dummy = dst_ptr->reported;
+
+	checkit = sh_files_filecheck (file_class_next, 
 				      iname, 
 				      dirlist->sh_d_name,
 				      &dummy, 0);
 
-	
-	SH_MUTEX_LOCK_UNSAFE(mutex_zfiles);
-	dst_ptr         = (dirstack_t *) zAVLSearch(zfileList, tmpcat);
-
 	if (dst_ptr && checked_flag == S_FALSE)
 	  dst_ptr->checked = S_TRUE;
-
 	/* Thu Mar  7 15:09:40 CET 2002 Propagate the 'reported' flag
 	 */
 	if (dst_ptr && sh.flag.reportonce == S_TRUE)
-	  dst_ptr->is_reported = dummy;
-
-	if (dst_ptr)
-	  dst_ptr->childs_checked = S_TRUE;
-	SH_MUTEX_UNLOCK_UNSAFE(mutex_zfiles);
+	  dst_ptr->reported = dummy;
       }
     
     if      (checkit == SH_FILE_REGULAR)   
-      ++theDir->NumRegular;
+      ++theDir.NumRegular;
     
     else if (checkit == SH_FILE_DIRECTORY) 
       {
-	++theDir->NumDirs;
-
+	++theDir.NumDirs;
 	if (rdepth_next >= 0 && cchecked_flag != S_TRUE) 
 	  {
@@ -2517,74 +1712,57 @@
 	    cchecked_flag = -1;
 	    
-	    SH_MUTEX_RECURSIVE_INIT(mutex_zdirs);
-	    SH_MUTEX_RECURSIVE_LOCK(mutex_zdirs);
-	    tmp_ptr     = (dirstack_t *) zAVLSearch(zdirListOne, tmpcat);
-
-	    if (tmp_ptr) 
+	    dst_ptr     = (dirstack_t *) zAVLSearch(zdirListOne, tmpcat);
+
+	    if (dst_ptr) 
 	      {
 		TPT((0, FIL__, __LINE__, 
 		     _("msg=<%s -> recursion depth %d\n>"),
-		     tmp_ptr->name, tmp_ptr->rdepth));
-		rdepth_next   = tmp_ptr->rdepth;
-		class_next    = tmp_ptr->class;
-		check_flags_next = tmp_ptr->check_flags;
+		     dst_ptr->name, dst_ptr->rdepth));
+		rdepth_next   = dst_ptr->rdepth;
+		class_next    = dst_ptr->class;
 		/* 28. Aug 2001 reversed
 		 */
-		cchecked_flag = tmp_ptr->childs_checked;
-		checked_flag  = tmp_ptr->checked;
+		cchecked_flag = dst_ptr->childs_checked;
+		checked_flag  = dst_ptr->checked;
+		break;
 	      }
 	    
 	    if (checked_flag == -1)
 	      {
-		tmp_ptr     = (dirstack_t *) zAVLSearch(zdirListTwo, tmpcat);
-
-		if (tmp_ptr) 
+		dst_ptr     = (dirstack_t *) zAVLSearch(zdirListTwo, tmpcat);
+
+		if (dst_ptr) 
 		  {
 		    TPT((0, FIL__, __LINE__, 
 			 _("msg=<%s -> recursion depth %d\n>"),
-			 tmp_ptr->name, tmp_ptr->rdepth));
-		    rdepth_next   = tmp_ptr->rdepth;
-		    class_next    = tmp_ptr->class;
-		    check_flags_next = tmp_ptr->check_flags;
+			 dst_ptr->name, dst_ptr->rdepth));
+		    rdepth_next   = dst_ptr->rdepth;
+		    class_next    = dst_ptr->class;
 		    /* 28. Aug 2001 reversed
 		     */
-		    cchecked_flag = tmp_ptr->childs_checked;
-		    checked_flag  = tmp_ptr->checked;
+		    cchecked_flag = dst_ptr->childs_checked;
+		    checked_flag  = dst_ptr->checked;
+		    break;
 		  }
 	      }
-
-	    if (tmp_ptr && cchecked_flag == S_FALSE)
-	      {
-		tmp_ptr->childs_checked = S_TRUE;
-		/*
-		 * 04. Feb 2006 avoid double checking
-		 */
-		tmp_ptr->checked        = S_TRUE;
-	      }
-	    SH_MUTEX_RECURSIVE_UNLOCK(mutex_zdirs);
-
+	    
 	    if (cchecked_flag == S_FALSE)
 	      {
-		sh_files_checkdir (class_next, check_flags_next, rdepth_next, 
-				   tmpcat, dirlist->sh_d_name);
-		/*
-		  tmp_ptr->childs_checked = S_TRUE;
-		  tmp_ptr->checked        = S_TRUE;
-		*/
+		sh_files_checkdir (class_next, rdepth_next, tmpcat, 
+				   dirlist->sh_d_name);
+		dst_ptr->childs_checked = S_TRUE;
 	      }
 	    else if (checked_flag == -1)
-	      sh_files_checkdir (class_next, check_flags_next, rdepth_next, 
-				 tmpcat, dirlist->sh_d_name);
+	      sh_files_checkdir (class_next, rdepth_next, tmpcat, 
+				 dirlist->sh_d_name);
 	    
 	  }
       }
     
-    else if (checkit == SH_FILE_SYMLINK)   ++theDir->NumSymlinks;
-    else if (checkit == SH_FILE_FIFO)      ++theDir->NumFifos;
-    else if (checkit == SH_FILE_SOCKET)    ++theDir->NumSockets;
-    else if (checkit == SH_FILE_CDEV)      ++theDir->NumCDev;
-    else if (checkit == SH_FILE_BDEV)      ++theDir->NumBDev;
-    else if (checkit == SH_FILE_DOOR)      ++theDir->NumDoor;
-    else if (checkit == SH_FILE_PORT)      ++theDir->NumPort;
+    else if (checkit == SH_FILE_SYMLINK)   ++theDir.NumSymlinks;
+    else if (checkit == SH_FILE_FIFO)      ++theDir.NumFifos;
+    else if (checkit == SH_FILE_SOCKET)    ++theDir.NumSockets;
+    else if (checkit == SH_FILE_CDEV)      ++theDir.NumCDev;
+    else if (checkit == SH_FILE_BDEV)      ++theDir.NumBDev;
     
     SH_FREE(tmpcat);
@@ -2592,29 +1770,21 @@
     if ((sig_termfast == 1) || (sig_terminate == 1)) 
       {
-	SH_FREE(theDir);
-	sh_dummy_dirlist = NULL;
-	SH_FREE(tmpname);
 	SL_RETURN((0), _("sh_files_checkdir"));
       }
     
     dirlist = dirlist->next;
-
-    /* -- moved up, only affects zfileList anyway
-     * if (dst_ptr)
-     *   dst_ptr->childs_checked = S_TRUE;
-     */
-
+    
   } while (dirlist != NULL);
 
-  if (flag_err_info == S_TRUE)
+  if (flag_err_info == SL_TRUE)
     {
       sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_FI_DSUM,
-		       theDir->NumDirs,
-		       theDir->NumRegular,
-		       theDir->NumSymlinks,
-		       theDir->NumFifos,
-		       theDir->NumSockets,
-		       theDir->NumCDev,
-		       theDir->NumBDev);
+		       theDir.NumDirs,
+		       theDir.NumRegular,
+		       theDir.NumSymlinks,
+		       theDir.NumFifos,
+		       theDir.NumSockets,
+		       theDir.NumCDev,
+		       theDir.NumBDev);
     }
 
@@ -2625,15 +1795,12 @@
    * Hardlink check; not done on MacOS X because of resource forks
    */
-  if ((sh_check_hardlinks == S_TRUE) && (hardlink_num != theDir->NumDirs)) 
-    {
-      if (0 != sh_files_hle_test(hardlink_num-theDir->NumDirs, iname))
+  if ((sh_check_hardlinks == S_TRUE) && (hardlink_num != theDir.NumDirs)) 
+    {
+      if (0 != sh_files_hle_test(hardlink_num-theDir.NumDirs, iname))
 	{
-	  len = strlen(tmpname);
-	  if (sl_ok_adds(len, 256)) 
-	    len += 256;
-	  tmpcat = SH_ALLOC(len);
-	  sl_snprintf(tmpcat, len, 
+	  tmpcat = SH_ALLOC(strlen(tmpname) + 256);
+	  sl_snprintf(tmpcat, strlen(tmpname) + 256, 
 		      _("%s: subdirectory count (%d) != hardlinks (%d)"),
-		      tmpname, theDir->NumDirs, hardlink_num);
+		      tmpname, theDir.NumDirs, hardlink_num);
 	  sh_error_handle (ShDFLevel[SH_ERR_T_DIR], FIL__, __LINE__, 0, 
 			   MSG_E_SUBGEN, tmpcat, _("sh_files_checkdir"));
@@ -2644,78 +1811,31 @@
 
   SH_FREE(tmpname);
-  SH_FREE(theDir);
-
-  sh_dummy_dirlist = NULL;
 
   SL_RETURN((0), _("sh_files_checkdir"));
 }
 
-void sh_files_fixup_mask (int class, unsigned long * check_flags)
-{
-  if (class == SH_LEVEL_ALLIGNORE)
-    MODI_SET((*check_flags), MODI_ALLIGNORE);
-  sh_tiger_get_mask_hashtype(check_flags);
-  return;
-}
-
 int get_the_fd (SL_TICKET ticket);
 
-static int sh_use_rsrc = S_FALSE;
-
-int sh_files_use_rsrc(const char * str)
-{
-  return sh_util_flagval(str, &sh_use_rsrc);
-}
-
-static void * sh_dummy_fileName;
-static void * sh_dummy_tmpname;
-static void * sh_dummy_tmpdir;
-
-ShFileType sh_files_filecheck (int class, unsigned long check_flags,
-			       const char * dirName, 
-			       const char * infileName,
-			       int * reported, 
-			       int rsrcflag)
+
+static ShFileType sh_files_filecheck (int class, char * dirName, 
+				      char * fileName,
+				      int * reported, 
+				      int rsrcflag)
 {
   /* 28 Aug 2001 allow NULL fileName
    */
-  char          * fullpath;
-  char            fileHash[2*(KEY_LEN + 1)];
+  char            fullpath[PATH_MAX];
+  char            fileHash[KEY_LEN + 1];
   int             status;
-  file_type     * theFile;
+  file_type       theFile;
   char          * tmpdir;
   char          * tmpname;
-  const char    * fileName;
-#if !defined(O_NOATIME)
   struct utimbuf  utime_buf;
-#endif
-  static unsigned int state = 1;
-  char            sc;
 
   SL_ENTER(_("sh_files_filecheck"));
 
-  fullpath = SH_ALLOC(PATH_MAX);
-  theFile  = SH_ALLOC(sizeof(file_type));
-
-  /* Take the address to keep gcc from putting it into a register. 
-   * Avoids the 'clobbered by longjmp' warning. 
-   */
-  sh_dummy_fileName = (void *) &fileName;
-  sh_dummy_tmpname  = (void *) &tmpname;
-  sh_dummy_tmpdir   = (void *) &tmpdir;
-
   BREAKEXIT(sh_derr);
-
-  if (0 == (simple_rand(&state) % 2)) (void) sh_derr();
-
-  if (dirName && infileName && (dirName[0] == '/') && (dirName[1] == '\0')
-      && (infileName[0] == '/') && (infileName[1] == '\0'))
-    {
-      fileName = NULL;
-    }
-  else
-    {
-      fileName = infileName;
-    }
+  if (0 == (rand() % 2))
+    (void) sh_derr();
 
   /* fileName may be NULL if this is a directory
@@ -2723,9 +1843,5 @@
   if (dirName == NULL /* || fileName == NULL */)
     {
-      SH_MUTEX_LOCK(mutex_thread_nolog);
       sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_FI_NULL);
-      SH_MUTEX_UNLOCK(mutex_thread_nolog);
-      SH_FREE(fullpath);
-      SH_FREE(theFile);
       SL_RETURN(SH_FILE_UNKNOWN, _("sh_files_filecheck"));
     }
@@ -2738,9 +1854,7 @@
 	{
 	  tmpname = sh_util_safe_name (fileName);
-	  SH_MUTEX_LOCK(mutex_thread_nolog);
 	  sh_error_handle (ShDFLevel[SH_ERR_T_NAME], FIL__, __LINE__, 0,
 			   MSG_FI_OBSC2,
 			   "", tmpname);
-	  SH_MUTEX_UNLOCK(mutex_thread_nolog);
 	  SH_FREE(tmpname);
 	}
@@ -2749,9 +1863,7 @@
 	  tmpdir  = sh_util_safe_name (dirName);
 	  tmpname = sh_util_safe_name (fileName);
-	  SH_MUTEX_LOCK(mutex_thread_nolog);
 	  sh_error_handle (ShDFLevel[SH_ERR_T_NAME], FIL__, __LINE__, 0,
 			   MSG_FI_OBSC2,
 			   tmpdir, tmpname);
-	  SH_MUTEX_UNLOCK(mutex_thread_nolog);
 	  SH_FREE(tmpname);
 	  SH_FREE(tmpdir);
@@ -2765,23 +1877,18 @@
       tmpdir  = sh_util_safe_name (dirName);
       tmpname = sh_util_safe_name (fileName);
-      SH_MUTEX_LOCK(mutex_thread_nolog);
       sh_error_handle (ShDFLevel[SH_ERR_T_FILE],  FIL__, __LINE__, 0,
 		       MSG_FI_2LONG2,
 		       tmpdir, tmpname);
-      SH_MUTEX_UNLOCK(mutex_thread_nolog);
       SH_FREE(tmpname);
       SH_FREE(tmpdir);
-      SH_FREE(fullpath);
-      SH_FREE(theFile);
       SL_RETURN(SH_FILE_UNKNOWN, _("sh_files_filecheck"));
     } 
 
+
   /* stat the file and determine checksum (if a regular file)
    */
-  sl_strlcpy (theFile->fullpath, fullpath, PATH_MAX);
-  theFile->check_flags    = check_flags /* sh_files_maskof(class) */;
-  theFile->file_reported = (*reported);
-  theFile->attr_string   = NULL;
-  theFile->link_path     = NULL;
+  sl_strlcpy (theFile.fullpath, fullpath, PATH_MAX);
+  theFile.check_mask = sh_files_maskof(class);
+  theFile.reported   = (*reported);
 
   TPT(( 0, FIL__, __LINE__, _("msg=<checking file: %s>\n"),  fullpath));
@@ -2790,6 +1897,6 @@
 			     ShDFLevel[class] : ShDFLevel[SH_ERR_T_FILE], 
 			     fileName,
-			     theFile, fileHash, class);
-
+			     &theFile, fileHash, class);
+  
   if (status != 0)
     {
@@ -2797,9 +1904,5 @@
 	    fullpath, status));
       if (class == SH_LEVEL_ALLIGNORE && sh.flag.checkSum != SH_CHECK_INIT)
-	sh_hash_set_visited_true (fullpath);
-      if (theFile->attr_string) SH_FREE(theFile->attr_string);
-      if (theFile->link_path)   SH_FREE(theFile->link_path);
-      SH_FREE(fullpath);
-      SH_FREE(theFile);
+	  sh_hash_set_visited_true (fullpath);
       SL_RETURN(SH_FILE_UNKNOWN, _("sh_files_filecheck"));
     }
@@ -2811,27 +1914,23 @@
   /* report
    */
-  if ((flag_err_debug == S_TRUE) && (theFile->c_mode[0] == '-'))
+  if ((flag_err_debug == SL_TRUE) && (theFile.c_mode[0] == '-'))
     {
       tmpname = sh_util_safe_name (fullpath); /* fixed in 1.5.4 */
-      SH_MUTEX_LOCK(mutex_thread_nolog);
       sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_FI_CSUM,
 		       fileHash, tmpname);
-      SH_MUTEX_UNLOCK(mutex_thread_nolog);
       SH_FREE(tmpname);
     } 
   ++sh.statistics.files_checked;
       
-  if ( sh.flag.checkSum == SH_CHECK_INIT) 
-    {
-      if (class == SH_LEVEL_ALLIGNORE)
-	MODI_SET(theFile->check_flags, MODI_ALLIGNORE);
-      if (S_TRUE == sh_ignore_chk_mod(theFile->fullpath))
-	MODI_SET(theFile->check_flags, MODI_NOCHECK);
-      sh_tiger_get_mask_hashtype(&(theFile->check_flags));
-
-      sh_dbIO_rootfs_strip(theFile->fullpath);
-      if (theFile->link_path)
-	sh_dbIO_rootfs_strip_link(theFile->link_path);
-      sh_dbIO_data_write (theFile, fileHash);
+  if      ( sh.flag.checkSum == SH_CHECK_INIT && sh.flag.update == S_FALSE ) 
+    {
+      sh_hash_pushdata (&theFile, fileHash);
+    }
+  else if (sh.flag.checkSum == SH_CHECK_INIT && sh.flag.update == S_TRUE )
+    {
+      if (0 == sh_hash_compdata (class, &theFile, fileHash, NULL, -1))
+	{
+	  sh_hash_pushdata (&theFile, fileHash);
+	}
     }
   else if (sh.flag.checkSum == SH_CHECK_CHECK 
@@ -2840,39 +1939,30 @@
 	   ) 
     {
-      if (sh.flag.update == S_TRUE)
-	{
-	  if (class == SH_LEVEL_ALLIGNORE)
-	    MODI_SET(theFile->check_flags, MODI_ALLIGNORE);
-	  if (S_TRUE == sh_ignore_chk_mod(theFile->fullpath))
-	    MODI_SET(theFile->check_flags, MODI_NOCHECK);
-	  sh_tiger_get_mask_hashtype(&(theFile->check_flags));
-	}
-      sh_hash_compdata (class, theFile, fileHash, NULL, -1);
+      sh_hash_compdata (class, &theFile, fileHash, NULL, -1);
     }
   
-  (*reported) = theFile->file_reported;
+  (*reported) = theFile.reported;
 
   /* reset the access time 
    */
+  if (class == SH_LEVEL_NOIGNORE && (theFile.check_mask & MODI_ATM) != 0)
+    {
+      utime_buf.actime   = (time_t) theFile.atime;
+      utime_buf.modtime  = (time_t) theFile.mtime;
 #if !defined(O_NOATIME)
-  if (class == SH_LEVEL_NOIGNORE && (theFile->check_flags & MODI_ATM) != 0)
-    {
-      utime_buf.actime   = (time_t) theFile->atime;
-      utime_buf.modtime  = (time_t) theFile->mtime;
-
       retry_aud_utime (FIL__, __LINE__, fullpath, &utime_buf);
-    }
-#endif
+#endif
+    }
   
-#if defined(HOST_IS_DARWIN)
+#ifdef HOST_IS_DARWIN
   /*
    * Check for resource fork
    */
-  if ( (sh_use_rsrc == S_TRUE) && (theFile->c_mode[0] != 'd') && (rsrcflag == 0) )
+  if ( (theFile.c_mode[0] != 'd') && (rsrcflag == 0) )
     {
       int  dummy;
       static int rsrc_init = 0;
       static char rsrc[17];
-      char * testpath = SH_ALLOC(PATH_MAX);
+      char testpath[PATH_MAX];
 
       if (rsrc_init == 0) {
@@ -2886,25 +1976,17 @@
       if (sl_strlen(testpath) == (17 + sl_strlen(fullpath)))
 	{
-	  if (S_TRUE == sh_unix_file_exists (testpath))
+	  if (0 == sh_unix_file_stat (testpath))
 	    {
-	      sh_files_filecheck (class, check_flags, fullpath, rsrc, &dummy, 1);
+	      sh_files_filecheck (class, fullpath, rsrc, &dummy, 1);
 	    }
 	}
-      SH_FREE(testpath);
     }
 #else
-  (void) rsrcflag; /* avoid compiler warning */
+      (void) rsrcflag; /* avoid compiler warning */
 #endif
 
  ret_point:
 
-  sc = theFile->c_mode[0];
-
-  if (theFile->attr_string) SH_FREE(theFile->attr_string);
-  if (theFile->link_path)   SH_FREE(theFile->link_path);
-  SH_FREE(fullpath);
-  SH_FREE(theFile);
-
-  switch (sc) 
+  switch (theFile.c_mode[0]) 
     {
     case '-': SL_RETURN(SH_FILE_REGULAR, _("sh_files_filecheck"));   
@@ -2914,6 +1996,4 @@
     case 'b': SL_RETURN(SH_FILE_BDEV, _("sh_files_filecheck"));      
     case '|': SL_RETURN(SH_FILE_FIFO, _("sh_files_filecheck"));      
-    case 'D': SL_RETURN(SH_FILE_DOOR, _("sh_files_filecheck"));    
-    case 'P': SL_RETURN(SH_FILE_PORT, _("sh_files_filecheck"));    
     case 's': SL_RETURN(SH_FILE_SOCKET, _("sh_files_filecheck"));    
     default:  SL_RETURN(SH_FILE_UNKNOWN, _("sh_files_filecheck"));   
@@ -2925,6 +2005,5 @@
 /* concatenate statpath = testdir"/"d_name
  */
-static int sh_files_fullpath (const char * testdir, const char * d_name, 
-			      char * statpath)
+static int sh_files_fullpath (char * testdir, char * d_name, char * statpath)
 {
   int llen = 0;
@@ -2951,160 +2030,4 @@
 }
 
-/* -----------------------------------
- * Routines required for inotify 
- * -----------------------------------
- */
-int sh_files_search_dir(char * name, int * class, 
-			unsigned long *check_flags, int *reported,
-			int * rdepth)
-{
-  volatile int retval = 0;
-#if defined(HAVE_GLOB_H) && defined(HAVE_FNMATCH_H)
-  sh_globstack_t * testPattern;
-  zAVLCursor   cursor;
-#endif
-  dirstack_t * item;
-
-  SH_MUTEX_RECURSIVE_INIT(mutex_zdirs);
-  SH_MUTEX_RECURSIVE_LOCK(mutex_zdirs);
-
-  item = zAVLSearch(zdirListOne, name);
-
-  if (item)
-    {
-      *check_flags = item->check_flags;
-      *class      = item->class;
-      *reported   = item->is_reported;
-      *rdepth     = item->rdepth;
-      item->checked        = S_FALSE;
-      item->childs_checked = S_FALSE;
-      item->is_reported    = S_FALSE;
-      retval = 1;
-      goto out;
-    }
-
-  item = zAVLSearch(zdirListTwo, name);
-
-  if (item)
-    {
-      *check_flags = item->check_flags;
-      *class      = item->class;
-      *reported   = item->is_reported;
-      *rdepth     = item->rdepth;
-      item->checked        = S_FALSE;
-      item->childs_checked = S_FALSE;
-      item->is_reported    = S_FALSE;
-      retval = 1;
-      goto out;
-    }
-
-#if defined(HAVE_GLOB_H) && defined(HAVE_FNMATCH_H)
-  SH_MUTEX_LOCK(mutex_zglob);
-  for (testPattern = (sh_globstack_t *) zAVLFirst (&cursor, zglobList); 
-       testPattern;
-       testPattern = (sh_globstack_t *) zAVLNext  (&cursor))
-    {
-      if (testPattern->type == SH_LIST_DIR1 || 
-	  testPattern->type == SH_LIST_DIR2)
-	{
-	  if (0 == fnmatch(testPattern->name, name, FNM_PATHNAME|FNM_PERIOD))
-	    {
-	      *check_flags = testPattern->check_flags;
-	      *class      = testPattern->class;
-	      *rdepth     = testPattern->rdepth;
-	      retval = 1;
-	      break;
-	    }
-	
-	}
-    }
-  SH_MUTEX_UNLOCK(mutex_zglob);
-#endif
- out:
-  ; /* 'label at end of compound statement' */
-  SH_MUTEX_RECURSIVE_UNLOCK(mutex_zdirs);
-  return retval;
-}
-
-int sh_files_search_file(char * name, int * class, 
-			 unsigned long *check_flags, int *reported)
-{
-  volatile int retval = 0;
-#if defined(HAVE_GLOB_H) && defined(HAVE_FNMATCH_H)
-  sh_globstack_t * testPattern;
-  zAVLCursor   cursor;
-#endif
-  dirstack_t * item;
-
-  SH_MUTEX_LOCK(mutex_zfiles);
-  item = zAVLSearch(zfileList, name);
-
-  if (item)
-    {
-      *check_flags = item->check_flags;
-      *class      = item->class;
-      *reported   = item->is_reported;
-      retval = 1;
-    }
-  SH_MUTEX_UNLOCK(mutex_zfiles);
-
-#if defined(HAVE_GLOB_H) && defined(HAVE_FNMATCH_H)
-  if (retval == 0)
-    {
-      SH_MUTEX_LOCK(mutex_zglob);
-      for (testPattern = (sh_globstack_t *) zAVLFirst (&cursor, zglobList); 
-	   testPattern;
-	   testPattern = (sh_globstack_t *) zAVLNext  (&cursor))
-	{
-	  if (testPattern->type == SH_LIST_FILE)
-	    {
-	      if (0 == fnmatch(testPattern->name, name, 
-			       FNM_PATHNAME|FNM_PERIOD))
-		{
-		  *check_flags = testPattern->check_flags;
-		  *class      = testPattern->class;
-		  retval = 1;
-		  break;
-		}
-	      
-	    }
-	}
-      SH_MUTEX_UNLOCK(mutex_zglob);
-    }
-#endif
-
-  return retval;
-}
-
-void sh_files_set_file_reported(const char * name)
-{
-  dirstack_t * item;
-
-  SH_MUTEX_LOCK_UNSAFE(mutex_zfiles);
-  item = zAVLSearch(zfileList, name);
-
-  if (item)
-    {
-      if (sh.flag.reportonce == S_TRUE)
-	SET_SH_FFLAG_REPORTED(item->is_reported);
-    }
-  SH_MUTEX_UNLOCK_UNSAFE(mutex_zfiles);
-  return;
-}
-
-void sh_files_clear_file_reported(const char * name)
-{
-  dirstack_t * item;
-
-  SH_MUTEX_LOCK_UNSAFE(mutex_zfiles);
-  item = zAVLSearch(zfileList, name);
-
-  if (item)
-    {
-      CLEAR_SH_FFLAG_REPORTED(item->is_reported);
-    }
-  SH_MUTEX_UNLOCK_UNSAFE(mutex_zfiles);
-  return;
-}
 
 /* -----------------------------------
@@ -3120,5 +2043,4 @@
   dirstack_t * pfilL;
   zAVLCursor   cursor;
-  volatile int retval = -1;
 
   SL_ENTER(_("check_file"));
@@ -3131,18 +2053,12 @@
     {
       if (0 == strcmp(name, pfilL->name) &&
-	  (pfilL->check_flags & MODI_ATM) == 0 &&
-	  (pfilL->check_flags & MODI_CTM) == 0 &&
-	  (pfilL->check_flags & MODI_MTM) == 0)
-	{
-	  retval = 0;
-	  break;
-	}
-    }
-
-  SL_RETURN(retval, _("check_file"));
-}
-
-static void * sh_dummy_pdirL;
-
+	  (pfilL->check_mask & MODI_ATM) == 0 &&
+	  (pfilL->check_mask & MODI_CTM) == 0 &&
+	  (pfilL->check_mask & MODI_MTM) == 0)
+	SL_RETURN(0, _("check_file"));
+    }
+  SL_RETURN((-1), _("check_file"));
+}
+  
 int sh_files_test_setup_int (zAVLTree * tree)
 {
@@ -3156,6 +2072,4 @@
   SL_ENTER(_("sh_files_test_setup"));
 
-  sh_dummy_pdirL = (void *) &pdirL;
-
   for (pdirL = (dirstack_t *) zAVLFirst (&cursor1, tree); pdirL;
        pdirL = (dirstack_t *) zAVLNext  (&cursor1))
@@ -3163,5 +2077,4 @@
       dlen = strlen(pdirL->name);
 
-      SH_MUTEX_LOCK(mutex_zfiles);
       for (pfilL = (dirstack_t *) zAVLFirst (&cursor2, zfileList); pfilL;
 	   pfilL = (dirstack_t *) zAVLNext  (&cursor2))
@@ -3183,7 +2096,7 @@
 		  (0 == strncmp(pfilL->name, pdirL->name, dlen)))
 		{
-		  if ((pdirL->check_flags & MODI_ATM) != 0  ||
-		      (pdirL->check_flags & MODI_MTM) != 0  ||
-		      (pdirL->check_flags & MODI_CTM) != 0)
+		  if ((pdirL->check_mask & MODI_ATM) != 0  ||
+		      (pdirL->check_mask & MODI_MTM) != 0  ||
+		      (pdirL->check_mask & MODI_CTM) != 0)
 		    {
 		      if (check_file (pdirL->name) != 0)
@@ -3194,5 +2107,4 @@
 	    }
 	}
-      SH_MUTEX_UNLOCK(mutex_zfiles);
     }
 
@@ -3202,6 +2114,9 @@
 int sh_files_test_double (zAVLTree * firstList, zAVLTree * secondList)
 {
+  int          count;
   int          retval = 0;
+
   zAVLCursor   cursor;
+
   dirstack_t * first;
 
@@ -3212,4 +2127,5 @@
       if (NULL != zAVLSearch(secondList, first->name))
 	{
+	  ++count;
 	  sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_FI_DOUBLE,
 			   first->name);
@@ -3220,12 +2136,10 @@
 }
 
-extern void     aud_exit   (const char * file, int line, int fd);
+extern void     aud_exit   (char * file, int line, int fd);
       
 int sh_files_test_setup ()
 {
-  int retval;
-
-  SH_MUTEX_RECURSIVE_INIT(mutex_zdirs);
-  SH_MUTEX_RECURSIVE_LOCK(mutex_zdirs);
+  int retval = 0;
+
   /* Test for modifications allowed in ReadOnly directory
    */  
